TextBox = {}
tbmt = {}

function TextBox:new(sx,sy,sw,sh,stext,stmax)
	return setmetatable({x=sx,y=sy,w=sw,h=sh,tmax=stmax,timer=0,text=stext,last="",cKey="",focus=false},tbmt)
end

function TextBox:update(dt)
	local x,y = love.mouse.getX(),love.mouse.getY()
	if love.mouse.isDown("l") then
		if not(x>=self.x and x<=self.x+self.w and y>=self.y and y<=self.y+self.h) then
			self.focus = false
		end
	end
	if self.focus and love.keyboard.isDown(self.cKey) then
		if self.cKey == self.last then
			if self.timer >= self.tmax+0.07 then
				if self.cKey == "return" then
					self.text = self.text .. "\n"
				elseif self.cKey == "backspace" then
					self.text = string.sub(self.text,0,#self.text-1)
				elseif self.cKey == "tab" then
					self.text = self.text .. "\t"
				elseif self.cKey == "lshift" or cKey == "rshift" then
					
				elseif self.cKey == "kp0" then
					self.text = self.text .. "0"
				elseif self.cKey == "kp1" then
					self.text = self.text .. "1"
				elseif self.cKey == "kp2" then
					self.text = self.text .. "2"
				elseif self.cKey == "kp3" then
					self.text = self.text .. "3"
				elseif self.cKey == "kp4" then
					self.text = self.text .. "4"
				elseif self.cKey == "kp5" then
					self.text = self.text .. "5"
				elseif self.cKey == "kp6" then
					self.text = self.text .. "6"
				elseif self.cKey == "kp7" then
					self.text = self.text .. "7"
				elseif self.cKey == "kp8" then
					self.text = self.text .. "8"
				elseif self.cKey == "kp9" then
					self.text = self.text .. "9"
				else
					self.text = self.text .. self.cKey
				end
				self.timer = 0
				self.last = self.cKey
			else
				self.timer = self.timer + dt
			end
		else
			if self.timer >= self.tmax then
				if self.cKey == "return" then
					self.text = self.text .. "\n"
				elseif self.cKey == "backspace" then
					self.text = string.sub(self.text,0,#self.text-1)
				elseif self.cKey == "tab" then
					self.text = self.text .. "\t"
				elseif self.cKey == "lshift" or cKey == "rshift" then
					
				elseif self.cKey == "kp0" then
					self.text = self.text .. "0"
				elseif self.cKey == "kp1" then
					self.text = self.text .. "1"
				elseif self.cKey == "kp2" then
					self.text = self.text .. "2"
				elseif self.cKey == "kp3" then
					self.text = self.text .. "3"
				elseif self.cKey == "kp4" then
					self.text = self.text .. "4"
				elseif self.cKey == "kp5" then
					self.text = self.text .. "5"
				elseif self.cKey == "kp6" then
					self.text = self.text .. "6"
				elseif self.cKey == "kp7" then
					self.text = self.text .. "7"
				elseif self.cKey == "kp8" then
					self.text = self.text .. "8"
				elseif self.cKey == "kp9" then
					self.text = self.text .. "9"
				else
					self.text = self.text .. self.cKey
				end
				self.timer = 0
				self.last = self.cKey
			else
				self.timer = self.timer + dt
			end
		end
	else
		if x>=self.x and x<=self.x+self.w and y>=self.y and y<=self.y+self.h then
			self.focus = true
		end
	end
end

function TextBox:draw()
	love.graphics.printf(self.text, self.x, self.y, self.w, "left")
	love.graphics.rectangle("line",self.x,self.y,self.w,self.h)
end

tbmt.__index = TextBox